package dche;
import java.awt.geom.Point2D;
import fem.AbstractNodes;
import fem.result.Result;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * DCHE NX
 */
public class Dche extends AbstractNodes{

/** ̂̃CfbNX */
  public int fluid;

/** Ǔa */
  public double d1;

/** OǓa */
  public double d2;

/** Ǔ */
  public double t;

/** ʗ */
  public double qm;

/** ǔM` */
  public double conduct;

/** ߓ_ */
  public int count;

/** ڑߓ_|C^ */
  public int nodes2[];

/** ڑߓ_|C^ */
  public int nodes3[];

/** Oǒfʐ */
  protected double area1;

/** ǒfʐ */
  protected double area2;

/** Oǔa */
  protected double dr;

/**
 * DCHE \z
 * @param d1 Ǔa
 * @param d2 OǓa
 * @param t Ǔ
 * @param qm ʗ
 * @param conduct ǔM`
 * @param count ߓ_
 * @param nodes ߓ_|C^
 * @param nodes2 ڑߓ_|C^
 * @param nodes3 ڑߓ_|C^
 */
  public Dche(int fluid,double d1,double d2,double t,double qm,
      	      double conduct,int count,int nodes[],int nodes2[],
      	      int nodes3[]){
    this.fluid=fluid;
    this.d1=d1;
    this.d2=d2;
    this.t=t;
    this.qm=qm;
    this.conduct=conduct;
    this.count=count;
    this.nodes=nodes;
    this.nodes2=nodes2;
    this.nodes3=nodes3;
    dr=d2-(d1+2.0*t);
    area1=0.25*Math.PI*dr*(d2+d1+2.0*t);
    area2=0.25*Math.PI*d1*d1;
  }

//--------------------------------------------------------------------//
/**
 * ̂̃CfbNXԂ
 * @return ̂̃CfbNX
 */
  public int getFluid(){
    return fluid;
  }

//--------------------------------------------------------------------//
/**
 * ̂̃CfbNXݒ肷
 * @param fluid ̂̃CfbNX
 */
  public void setFluid(int fluid){
    this.fluid=fluid;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int nodeCount(){
    return count;
  }

//--------------------------------------------------------------------//
/**
 * ڑߓ_xԂ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽߓ_̃x
 */
  public int node2(int index){
    return nodes2[index];
  }

//--------------------------------------------------------------------//
/**
 * ڑߓ_xԂ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽߓ_̃x
 */
  public int node3(int index){
    return nodes3[index];
  }

//--------------------------------------------------------------------//
/**
 * ڑߓ_xĐݒ肷
 * @param index ߓ_̃CfbNX
 * @param label w肳ꂽʒuɐݒ肷郉x
 */
  public void resetNodeLabel2(int index,int label){
    nodes2[index]=label;
  }

//--------------------------------------------------------------------//
/**
 * ڑߓ_xĐݒ肷
 * @param index ߓ_̃CfbNX
 * @param label w肳ꂽʒuɐݒ肷郉x
 */
  public void resetNodeLabel3(int index,int label){
    nodes3[index]=label;
  }

//--------------------------------------------------------------------//
/**
 * M͂
 * @param result vZ
 * @param fluid ̕
 * @param p ߓ_i[z
 */
  public Matrix calc(Result result,Fluid fluid,Point2D p[]){
    double coef1=0.125*d2;
    double coef11=0.125*(d1+2.0*t);
    double coef12=0.125*d1;
    double coef13=0.25/(Math.log(d1+2.0*t)-Math.log(d1));
    double coef2=0.125*(d2+d1+2.0*t)*dr;
    double coef22=0.125*d1*d1;
    double coef3=2.0*qm*coef2/area1;
    double coef32=2.0*qm*coef22/area2;
    double t1[]=new double[count];
    double t2[]=new double[count];
    Matrix s=new DefaultMatrix(3*count-1);
    for(int i=0;i<count;i++){
      t1[i]=result.getTemperature(nodes[i]);
      t2[i]=result.getTemperature(nodes2[i]);
      FluidElement elem1=fluid.get(t1[i]);
      FluidElement elem2=fluid.get(t2[i]);
      double h1=elem1.htc(qm,dr,area1);
      double h2=elem2.htc(qm,d1,area2);
      double dx1=0.0;
      double dx2=0.0;
      if(i>0) dx1=p[i].distance(p[i-1]);
      if(i<count-1) dx2=p[i].distance(p[i+1]);
      double value=coef1*h1*(dx1+dx2);
      s.add(i,i,value);
      s.add(i,2*count+i-1,-value);
      s.add(2*count+i-1,i,-value);
      s.add(2*count+i-1,2*count+i-1,value);
      if(i<count-1){
      	double value1=coef11*h1;
      	double value2=coef12*h2;
      	double value3=coef13*conduct;
      	value=(dx1+dx2)/(1.0/value1+1.0/value2+1.0/value3);
      	s.add(i,i,value);
      	s.add(i,count+i,-value);
      	s.add(count+i,i,-value);
      	s.add(count+i,count+i,value);
      }
    }
    for(int i=0;i<count-1;i++){
      FluidElement elem=fluid.get(0.5*(t1[i]+t1[i+1]));
      double value=coef2*elem.heatConductivity/p[i].distance(p[i+1]);
      s.add(i,i,value);
      s.add(i,i+1,-value);
      s.add(i+1,i,-value);
      s.add(i+1,i+1,value);
      value=coef3*elem.specificHeat;
      s.add(i+1,i,-value);
      s.add(i+1,i+1,value);
      elem=fluid.get(0.5*(t2[i]+t2[i+1]));
      value=coef22*elem.heatConductivity/p[i].distance(p[i+1]);
      int i2=count+i+1;
      if(i==count-2) i2=i+1;
      s.add(count+i,count+i,value);
      s.add(count+i,i2,-value);
      s.add(i2,count+i,-value);
      s.add(i2,i2,value);
      value=coef32*elem.specificHeat;
      s.add(count+i,count+i,value);
      s.add(count+i,i2,-value);
    }
    return s;
  }
}
