package dche;

//--------------------------------------------------------------------//
/**
 * ̕vf
 */
public class FluidElement implements Cloneable{

/** x */
  public double density;

/** M */
  public double specificHeat;

/** M` */
  public double heatConductivity;

/** SW */
  public double viscocity;

/** vg */
  public double prandtl;

/**
 * ̕vf\z
 * @param density x
 * @param specificHeat M
 * @param heatConductivity M`
 * @param viscocity SW
 * @param prandtl vg
 */
  public FluidElement(double density,double specificHeat,
      	      	      double heatConductivity,double viscocity,
      	      	      double prandtl){
    this.density=density;
    this.specificHeat=specificHeat;
    this.heatConductivity=heatConductivity;
    this.viscocity=viscocity;
    this.prandtl=prandtl;
  }

//--------------------------------------------------------------------//
/**
 * M`BԂ
 * @param qm ʗ
 * @param l \
 * @param area fʐ
 * @return M`B
 */
  public double htc(double qm,double l,double area){
    double re=qm*l/(viscocity*area);
    double nu1=0.17*Math.pow(re,0.33);
    double nu2=((2.2809e-11*re-6.0044e-7)*re+8.3117e-3)*re-12.822;
    double nu3=0.021*Math.pow(re,0.8);
    double nu=Math.min(Math.max(nu1,nu2),nu3)*Math.pow(prandtl,0.43);
//System.out.println(viscocity+" "+re+" : "+nu);
    return heatConductivity*nu/l;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      return super.clone();
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    long ll[]={Double.doubleToLongBits(density),
      	       Double.doubleToLongBits(specificHeat),
      	       Double.doubleToLongBits(heatConductivity),
      	       Double.doubleToLongBits(viscocity),
      	       Double.doubleToLongBits(prandtl)};
    int bit=0;
    for(int i=0;i<ll.length;i++){
      bit=31*bit+(int)(ll[i]^(ll[i]>>>32));
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>FluidElement</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof FluidElement){
      FluidElement fe=(FluidElement)obj;
      return ((density==fe.density)
      	   && (specificHeat==fe.specificHeat)
      	   && (heatConductivity==fe.heatConductivity)
      	   && (viscocity==fe.viscocity)
      	   && (prandtl==fe.prandtl));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return density+"\t"+specificHeat+"\t"+heatConductivity+"\t"
      	  +viscocity+"\t"+prandtl;
  }
}
