package dche.component;

//--------------------------------------------------------------------//
/**
 * p`WNX
 */
public class PolygonCoordinates{

/** Wi[z */
  protected double s[];

/**
 * p`W\z
 * @param s Wi[z
 */
  protected PolygonCoordinates(double s[]){
    this.s=new double[s.length];
    System.arraycopy(s,0,this.s,0,s.length);
  }

//--------------------------------------------------------------------//
/**
 * WlԂ
 * @param index W̃CfbNX
 * @return w肳ꂽW
 */
  public double get(int index){
    return s[index];
  }

//--------------------------------------------------------------------//
/**
 * p`̒lԂ
 * @param value _ł̒li[z
 * @return ̒l
 */
  public double valueAt(double value[]){
    double sum=0.0;
    for(int i=0;i<s.length;i++) sum+=s[i]*value[i];
    return sum;
  }

//--------------------------------------------------------------------//
/**
 * Op`̍WԂ
 * @param x W߂_ <i>x</i> W
 * @param y W߂_ <i>y</i> W
 * @param gx _ <i>x</i> Wi[z
 * @param gy _ <i>y</i> Wi[z
 */
  public static PolygonCoordinates triangle(int x,int y,
      	      	      	      	      	    int gx[],int gy[]){
    int dx21=gx[1]-gx[0];
    int dy21=gy[1]-gy[0];
    int dx31=gx[2]-gx[0];
    int dy31=gy[2]-gy[0];
    int delta=dx21*dy31-dy21*dx31;
    int xsi=dy31*(x-gx[0])-dx31*(y-gy[0]);
    int eta=-dy21*(x-gx[0])+dx21*(y-gy[0]);
    double s[]=new double[3];
    s[1]=0.0;
    s[2]=0.0;
    if(delta==0){
      if(dx21!=0){
      	s[1]=(double)(x-gx[0])/(double)dx21;
      }
      else if(dx31!=0.0){
      	s[2]=(double)(x-gx[0])/(double)dx31;
      }
      else if(dy21!=0){
      	s[1]=(double)(y-gy[0])/(double)dy21;
      }
      else if(dy31!=0.0){
      	s[2]=(double)(y-gy[0])/(double)dy31;
      }
    }
    else{
      s[1]=(double)xsi/(double)delta;
      s[2]=(double)eta/(double)delta;
    }
    s[0]=1.0-s[1]-s[2];
    return new PolygonCoordinates(s);
  }

//--------------------------------------------------------------------//
/**
 * lp`̍WԂ
 * @param x W߂_ <i>x</i> W
 * @param y W߂_ <i>y</i> W
 * @param gx _ <i>x</i> Wi[z
 * @param gy _ <i>y</i> Wi[z
 */
  public static PolygonCoordinates quadangle(int x,int y,
      	      	      	      	      	     int gx[],int gy[]){
    int ax=gx[0]-gx[1]+gx[2]-gx[3];
    int ay=gy[0]-gy[1]+gy[2]-gy[3];
    int bx=gx[1]-gx[0];
    int by=gy[1]-gy[0];
    int cx=gx[3]-gx[0];
    int cy=gy[3]-gy[0];
    int dx=x-gx[0];
    int dy=y-gy[0];
    int delta1=bx*ay-by*ax;
    int delta2=cx*ay-cy*ax;
    int delta3=dx*ay-dy*ax;
    double s,t;
    if((ax==0) && (ay==0)){
      int delta4=bx*cy-by*cx;
      if(delta4==0) return null;
      s=(double)(cy*dx-cx*dy)/(double)delta4;
      t=(double)(-by*dx+bx*dy)/(double)delta4;
    }
    else if(delta1==0){
      if(delta2==0){
      	return null;
      }
      else{
      	t=(double)delta3/(double)delta2;
      	int delta4=ax*delta3+bx*delta2;
      	int delta5=ay*delta3+by*delta2;
      	if(delta4!=0){
      	  s=(double)(dx*delta2-cx*delta3)/(double)delta4;
      	}
      	else if(delta5!=0){
      	  s=(double)(dy*delta2-cy*delta3)/(double)delta5;
      	}
      	else{
      	  s=0.0;
      	}
      }
    }
    else if(delta2==0){
      s=(double)delta3/(double)delta1;
      int delta4=ax*delta3+cx*delta1;
      int delta5=ay*delta3+cy*delta1;
      if(delta4!=0){
      	t=(double)(dx*delta1-bx*delta3)/(double)delta4;
      }
      else if(delta5!=0){
      	t=(double)(dy*delta1-by*delta3)/(double)delta5;
      }
      else{
      	t=0.0;
      }
    }
    else if(ax!=0){
      int a1=delta3*ax+delta2*bx-delta1*cx;
      int a2=delta3*ax-delta2*bx+delta1*cx;
      int dd2=a1*a1+4*delta1*ax*(delta3*cx-delta2*dx);
      double dd=Math.sqrt((double)dd2);
      double stcoef1=1.0/(double)(2*delta1*ax);
      double stcoef2=1.0/(double)(2*delta2*ax);
      s=stcoef1*((double)a1+dd);
      t=stcoef2*((double)a2-dd);
      if((s<0.0) || (1.0<s) || (t<0.0) || (1.0<t)){
      	s=stcoef1*((double)a1-dd);
      	t=stcoef2*((double)a2+dd);
      }
    }
    else{
      int a1=delta3*ay+delta2*by-delta1*cy;
      int a2=delta3*ay-delta2*by+delta1*cy;
      int dd2=a1*a1+4*delta1*ay*(delta3*cy-delta2*dy);
      double dd=Math.sqrt((double)dd2);
      double stcoef1=1.0/(double)(2*delta1*ay);
      double stcoef2=1.0/(double)(2*delta2*ay);
      s=stcoef1*((double)a1+dd);
      t=stcoef2*((double)a2-dd);
      if((s<0.0) || (1.0<s) || (t<0.0) || (1.0<t)){
      	s=stcoef1*((double)a1-dd);
      	t=stcoef2*((double)a2+dd);
      }
    }
    return new PolygonCoordinates
      (new double[]{(1.0-s)*(1.0-t),s*(1.0-t),s*t,(1.0-s)*t});
  }
}
