package fem;
import java.awt.geom.Rectangle2D;
import java.util.ArrayList;
import java.util.Collections;

//--------------------------------------------------------------------//
/**
 * bVf
 */
public class MeshModel{

/** x̔rIuWFNg */
  public static final LabelComparator
    LABEL_COMPARATOR=new LabelComparator();

/** ߓ_W̔rIuWFNg */
  public static final NodesComparator
    NODES_COMPARATOR=new NodesComparator();

/** ߓ_i[Xg */
  protected ArrayList<Node> nodes;

/** vfi[Xg */
  protected ArrayList<Element2D> elements;

/** OEi[Xg */
  protected ArrayList<ElementBorder> freeBorder;

/** fE\ <code>Cube3D</code> */
  public Rectangle2D bounds;

/**
 * bVf\z
 */
  public MeshModel(){
    nodes=new ArrayList<Node>();
    elements=new ArrayList<Element2D>();
    freeBorder=new ArrayList<ElementBorder>();
    bounds=new Rectangle2D.Double();
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int getNodeCount(){
    return nodes.size();
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̐ߓ_
 */
  public Node getNode(int index){
    return nodes.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_ǉ
 * @param node ߓ_
 */
  public void addNode(Node node){
    nodes.add(node);
  }

//--------------------------------------------------------------------//
/**
 * vfԂ
 * @return vf
 */
  public int getElementCount(){
    return elements.size();
  }

//--------------------------------------------------------------------//
/**
 * vfԂ
 * @param index vf̃CfbNX
 * @return w肳ꂽʒu̗vf
 */
  public Element2D getElement(int index){
    return elements.get(index);
  }

//--------------------------------------------------------------------//
/**
 * vfǉ
 * @param element vf
 */
  public void addElement(Element2D element){
    elements.add(element);
  }

//--------------------------------------------------------------------//
/**
 * OE̐Ԃ
 * @return OE̐
 */
  public int getBorderCount(){
    return freeBorder.size();
  }

//--------------------------------------------------------------------//
/**
 * OEԂ
 * @param index OẼCfbNX
 * @return w肳ꂽʒůOE
 */
  public ElementBorder getFreeBorder(int index){
    return freeBorder.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @param nodes ߓ_W
 * @return ߓ_i[z
 */
  public Node[] nodes(Nodes nodes){
    int nodeCount=nodes.nodeCount();
    Node p[]=new Node[nodeCount];
    for(int j=0;j<nodeCount;j++){
      p[j]=getNode(nodes.node(j));
    }
    return p;
  }

//--------------------------------------------------------------------//
/**
 * bV
 */
  public void clear(){
    nodes.clear();
    elements.clear();
    freeBorder.clear();
    bounds=new Rectangle2D.Double();
  }

//--------------------------------------------------------------------//
/**
 * f
 */
  public void init(){
    nodes.trimToSize();
    elements.trimToSize();
    Collections.sort(nodes,LABEL_COMPARATOR);
    modelBounds();
  }

//--------------------------------------------------------------------//
/**
 * OEo
 */
  public void getFreeBorder(){
    int nodeCount=nodes.size();
    int elementCount=elements.size();
    if(elementCount==0) return;
    ArrayList<ElementBorder> border=new ArrayList<ElementBorder>();
    for(int i=0;i<elementCount;i++){
      Element2D element=getElement(i);
      int borderCount=element.borderCount();
      for(int j=0;j<borderCount;j++){
      	border.add(element.border(i,j));
      }
    }
    border.trimToSize();
    int borderCount=border.size();
    if(borderCount>0){
      Collections.sort(border,NODES_COMPARATOR);

      ElementBorder beforeeb=border.get(0);
      boolean addsw=true;
      for(int i=1;i<borderCount;i++){
      	ElementBorder eb=border.get(i);
      	if(beforeeb.equals(eb)){
      	  addsw=false;
      	}
      	else{
      	  if(addsw) freeBorder.add(beforeeb);
      	  beforeeb=eb;
      	  addsw=true;
      	}
      }
      if(addsw) freeBorder.add(beforeeb);
    }
    freeBorder.trimToSize();
  }

//--------------------------------------------------------------------//
/**
 * fEݒ肷
 */
  public void modelBounds(){
    int nodeCount=nodes.size();
    if(nodeCount==0) return;
    Node p=getNode(0);
    double xMax=p.x;
    double xMin=p.x;
    double yMax=p.y;
    double yMin=p.y;
    for(int i=1;i<nodeCount;i++){
      p=getNode(i);
      xMax=Math.max(p.x,xMax);
      xMin=Math.min(p.x,xMin);
      yMax=Math.max(p.y,yMax);
      yMin=Math.min(p.y,yMin);
    }
    bounds.setRect(xMin,yMin,xMax-xMin,yMax-yMin);
  }

//--------------------------------------------------------------------//
/**
 * fEԂ
 * @return fE\
 */
  public Rectangle2D getBounds(){
    return bounds;
  }
}
