package fem.bc;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import fem.ElementBorder;
import fem.LabelComparator;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * ENX
 */
public class BoundaryCondition{

/** x̔rIuWFNg */
  protected static final LabelComparator
    LABEL_COMPARATOR=new LabelComparator();

/** ߓ_xi[郊Xg */
  protected ArrayList<Temperature> temperature;

/** M`BEi[郊Xg */
  protected ArrayList<HeatTransferBound> htcs;

/** MEi[郊Xg */
  protected ArrayList<HeatFluxBound> flux;

/** ߓ_ */
  public int nodeCount;

/** Eݒ肵ߓ_̃CfbNXi[z **/
  public int bcList[];

/**
 * EIuWFNg\z
 */
  public BoundaryCondition(){
    temperature=new ArrayList<Temperature>();
    htcs=new ArrayList<HeatTransferBound>();
    flux=new ArrayList<HeatFluxBound>();
  }

//--------------------------------------------------------------------//
/**
 * xŒ̐Ԃ
 * @return xŒ̐
 */
  public int temperatureCount(){
    return temperature.size();
  }

//--------------------------------------------------------------------//
/**
 * xŒԂ
 * @param index xŒ̃CfbNX
 * @return w肳ꂽʒủxŒ
 */
  public Temperature getTemperature(int index){
    return temperature.get(index);
  }

//--------------------------------------------------------------------//
/**
 * xŒǉ
 * @param t xŒ
 */
  public void addTemperature(Temperature t){
    temperature.add(t);
  }

//--------------------------------------------------------------------//
/**
 * M`BE^ʂ̐Ԃ
 * @return M`BE^ʂ̐
 */
  public int htcCount(){
    return htcs.size();
  }

//--------------------------------------------------------------------//
/**
 * M`BEԂ
 * @param index M`BẼCfbNX
 * @return w肳ꂽʒu̔M`BE
 */
  public HeatTransferBound getHTBound(int index){
    return htcs.get(index);
  }

//--------------------------------------------------------------------//
/**
 * M`BEǉ
 * @param htc M`BE
 */
  public void addHTBound(HeatTransferBound htc){
    htcs.add(htc);
  }

//--------------------------------------------------------------------//
/**
 * ME^ʂ̐Ԃ
 * @return ME^ʂ̐
 */
  public int fluxCount(){
    return flux.size();
  }

//--------------------------------------------------------------------//
/**
 * MEԂ
 * @param index MẼCfbNX
 * @return w肳ꂽʒu̔ME
 */
  public HeatFluxBound getFluxBound(int index){
    return flux.get(index);
  }

//--------------------------------------------------------------------//
/**
 * MEǉ
 * @param f ME
 */
  public void addFluxBound(HeatFluxBound f){
    flux.add(f);
  }

//--------------------------------------------------------------------//
/**
 * E
 */
  public void clear(){
    temperature.clear();
    htcs.clear();
    flux.clear();
  }

//--------------------------------------------------------------------//
/**
 * E
 */
  public void init(){
    temperature.trimToSize();
    htcs.trimToSize();
    flux.trimToSize();
    Collections.sort(temperature,LABEL_COMPARATOR);
    Collections.sort(htcs,LABEL_COMPARATOR);
    Collections.sort(flux,LABEL_COMPARATOR);
  }

//--------------------------------------------------------------------//
/**
 * xŒi[XgԂ
 * @return xŒi[Xg
 */
  public ArrayList<Temperature> getTemperature(){
    return temperature;
  }

//--------------------------------------------------------------------//
/**
 * Eݒ肵ߓ_̃CfbNXݒ肷
 * @param nodeCount ߓ_
 * @return ߓ_Rx̍v
 */
  public int bcList(int nodeCount){
    this.nodeCount=nodeCount;
    int temperatureCount=temperatureCount();
    bcList=new int[nodeCount];
    Arrays.fill(bcList,-1);
    for(int i=0;i<temperatureCount;i++){
      Temperature temp=getTemperature(i);
      bcList[temp.label()]=i;
    }
    return temperatureCount;
  }

//--------------------------------------------------------------------//
/**
 * ׏dxNg쐬
 * @param dofAll fRx
 * @return ׏dxNg
 */
  public Vector loadVector(int dofAll){
    int temperatureCount=temperatureCount();
    Vector vector=new Vector(dofAll);
    for(int i=0;i<temperatureCount;i++){
      Temperature temp=getTemperature(i);
      vector.add(temp.label(),temp.temperature());
    }
    return vector;
  }
}
