package fem.border;
import java.awt.geom.Point2D;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * ӋENX
 */
public class EdgeBorder extends AbstractElementBorder{

/** vfE */
  public static final String BORDER_NAME="EdgeBorder";

/** ߓ_ */
  public static final int NODE_COUNT=2;

/**
 * vfE\z
 * @param element vfx
 * @param p1 ߓ_ԍ
 * @param p2 ߓ_ԍ
 */
  public EdgeBorder(int element,int p1,int p2){
    super(element);
    nodes=new int[NODE_COUNT];
    nodes[0]=p1;
    nodes[1]=p2;
  }

/**
 * vfE\z
 * @param element vfx
 * @param p ߓ_ԍi[z
 */
  public EdgeBorder(int element,int p[]){
    this(element,p[0],p[1]);
  }

//--------------------------------------------------------------------//
/**
 * vfÊԂ
 * @return vfE
 */
  public String getName(){
    return BORDER_NAME;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int nodeCount(){
    return NODE_COUNT;
  }

//--------------------------------------------------------------------//
/**
 * `֐}gbNX<br>
 * { <i>N<sub>i</sub>N<sub>j</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐}gbNX
 */
  public Matrix shapeFunctionMatrix(Point2D p[],double coef){
    Matrix s=new DefaultMatrix(NODE_COUNT);
    double value=coef*C1_3*0.5*(p[0].getX()+p[1].getX())
      	      	*p[0].distance(p[1]);
    s.set(0,0,value);
    s.set(0,1,0.5*value);
    s.set(1,0,0.5*value);
    s.set(1,1,value);
    return s;
  }

//--------------------------------------------------------------------//
/**
 * `֐xNg<br>
 * { <i>N<sub>i</sub> dS</i> }<br>
 * Ԃ
 * @param p ߓ_i[z
 * @param coef W
 * @return `֐xNg
 */
  public Vector shapeFunctionVector(Point2D p[],double coef){
    Vector s=new Vector(NODE_COUNT);
    double value=coef*0.25*(p[0].getX()+p[1].getX())
      	      	*p[0].distance(p[1]);
    s.set(0,value);
    s.set(1,value);
    return s;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @return rΏۂ̃IuWFNg <code>EdgeBorder</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof EdgeBorder){
      return super.equals(obj);
    }
    else{
      return false;
    }
  }
}
