package fem.result;
import java.util.ArrayList;
import java.util.Collections;
import fem.bc.BoundaryCondition;
import fem.bc.Temperature;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * vZʃNX
 */
public class Result{

/** f[^\ int ^ */
  public static final int NONE=-1;

/** x\ int ^ */
  public static final int TEMPERATURE=0;

/** ߓ_xi[郊Xg */
  protected ArrayList<Double> temperature;

/** x̍ől */
  protected double tempMax;

/** ͌ʂ̗L\ boolean ^ */
  protected boolean calculated;

/**
 * vZʃIuWFNg\z
 */
  public Result(){
    temperature=new ArrayList<Double>();
    tempMax=0.0;
    calculated=false;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_Ԃ
 * @return ߓ_
 */
  public int size(){
    return temperature.size();
  }

//--------------------------------------------------------------------//
/**
 * ͌ʂ̗L\ boolean ^Ԃ
 * @return ͌ʂ݂ꍇ true
 */
  public boolean calculated(){
    return calculated;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xꊇݒ肷
 * @param nodeCount ߓ_
 * @param t ߓ_x
 */
  public void fillTemperature(int nodeCount,double t){
    temperature.clear();
    for(int i=0;i<nodeCount;i++){
      temperature.add(t);
    }
    temperature.trimToSize();
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xݒ肷
 * @param bc E
 * @param t ߓ_x\xNg
 * @param temp ߓ_xi[Xg
 */
  public void setTemperature(BoundaryCondition bc,Vector t,
      	      	      	     ArrayList<Temperature> temp){
    int size=bc.nodeCount;
    temperature.clear();
    int ii=0;
    for(int i=0;i<size;i++){
      double tt=0.0;
      if(bc.bcList[i]<0){
      	tt=t.get(ii);
      	ii++;
      }
      else{
      	tt=temp.get(bc.bcList[i]).temperature();
      }
      tempMax=Math.max(tempMax,tt);
      temperature.add(tt);
    }
    temperature.trimToSize();
    calculated=true;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xԂ
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽʒu̐ߓ_x
 */
  public double getTemperature(int index){
    return temperature.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ߓ_xi[zԂ
 * @return ߓ_xi[z
 */
  public double[] getTemperatures(){
    int count=size();
    double t[]=new double[count];
    for(int i=0;i<count;i++){
      t[i]=getTemperature(i);
    }
    return t;
  }

//--------------------------------------------------------------------//
/**
 * ߓ_x̍őlԂ
 * @return ߓ_x̍ől
 */
  public double tempMax(){
    return tempMax;
  }

//--------------------------------------------------------------------//
/**
 * f[^o
 * @param param f[^̎ނ\ int ^
 * @param index ߓ_̃CfbNX
 * @return w肳ꂽf[^
 */
  public double getData(int param,int index){
    switch(param){
      case TEMPERATURE:
      	return getTemperature(index);
    }
    return 0.0;
  }

//--------------------------------------------------------------------//
/**
 * vZʂ
 */
  public void clear(){
    temperature.clear();
    tempMax=0.0;
    calculated=false;
  }
}
