package figure;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

//--------------------------------------------------------------------//
/**
 * asNX<br>
 * 0 łȂ̂݃f[^ێ
 */
public class SparseMatrix extends AbstractMatrix{

/** s̐ */
  protected int rowCount;

/** ̐ */
  protected int columnCount;

/** sf[^i[z */
  protected RowData rowdata[];

/**
 * s\z
 * @param size s̑傫
 */
  public SparseMatrix(int size){
    this(size,size);
  }

/**
 * s\z
 * @param rowCount s̐
 * @param columnCount ̐
 */
  public SparseMatrix(int rowCount,int columnCount){
    super();
    this.rowCount=rowCount;
    this.columnCount=columnCount;
    rowdata=new RowData[rowCount];
    for(int i=0;i<rowCount;i++){
      rowdata[i]=new RowData();
    }
  }

//--------------------------------------------------------------------//
/**
 * s̐Ԃ
 * @return s̐
 */
  public int rowCount(){
    return rowCount;
  }

//--------------------------------------------------------------------//
/**
 * ̐Ԃ
 * @return ̐
 */
  public int columnCount(){
    return columnCount;
  }

//--------------------------------------------------------------------//
/**
 *  0 łȂ̐Ԃ
 * @param row s
 * @return w肳ꂽsŐ 0 łȂ̐
 */
  public int columnCount(int row){
    return rowdata[row].size();
  }

//--------------------------------------------------------------------//
/**
 * 0 łȂ̐Ԃ
 * @return 0 łȂ̐
 */
  public int getNonZeroCount(){
    int count=0;
    for(int i=0;i<rowCount;i++){
      count+=rowdata[i].size();
    }
    return count;
  }

//--------------------------------------------------------------------//
/**
 * Ԃ
 * @param row s
 * @param column 
 * @return w肳ꂽʒu̐
 */
  public double get(int row,int column){
    checkRange(row,column);
    return rowdata[row].get(column);
  }

//--------------------------------------------------------------------//
/**
 * ΊpԂ
 * @param row s
 * @return w肳ꂽs̑Ίp
 */
  public double getDiagonal(int row){
    return rowdata[row].getDiagonal();
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @param row s
 * @param column 
 * @return w肳ꂽʒu̐f[^
 */
  public Data getData(int row,int column){
    try{
      return rowdata[row].getData(column);
    }
    catch(Exception ex){
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * Ίpf[^̗CfbNXԂ
 * @param row s
 * @return w肳ꂽs̑Ίpf[^̗CfbNX
 */
  public int getDiagonalColumn(int row){
    return rowdata[row].diagonal;
  }

//--------------------------------------------------------------------//
/**
 * sf[^Ԃ
 * @param row s
 * @return w肳ꂽs̐f[^i[Xg
 */
  public RowData getRowData(int row){
    return rowdata[row];
  }

//--------------------------------------------------------------------//
/**
 * ɒlݒ肷
 * @param row s
 * @param column 
 * @param value ݒ肷l
 */
  public void set(int row,int column,double value){
    checkRange(row,column);
    rowdata[row].set(column,value);
  }

//--------------------------------------------------------------------//
/**
 * sf[^ݒ肷
 * @param row s
 * @param rowdata sf[^
 */
  public void setRowData(int row,RowData rowdata){
    this.rowdata[row]=(RowData)rowdata.clone();
  }

//--------------------------------------------------------------------//
/**
 * ɒl
 * @param row s
 * @param column 
 * @param value l
 */
  public void add(int row,int column,double value){
    checkRange(row,column);
    rowdata[row].add(column,value);
  }

//--------------------------------------------------------------------//
/**
 * s
 * @param m s
 */
  public void add(Matrix m){
    if((rowCount!=m.rowCount()) || (columnCount!=m.columnCount())){
      return;
    }
    if(m instanceof SparseMatrix){
      SparseMatrix sm=(SparseMatrix)m;
      for(int i=0;i<rowCount;i++){
      	int columns=rowdata[i].size();
      	for(int j=0;j<columns;j++){
      	  Data data=sm.getData(i,j);
      	  add(i,data.column,data.value);
      	}
      }
    }
    else{
      for(int i=0;i<rowCount;i++){
      	for(int j=0;j<columnCount;j++){
      	  if(Math.abs(m.get(i,j))>Double.MIN_VALUE){
      	    add(i,j,m.get(i,j));
      	  }
      	}
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * XJ[|
 * @param value |XJ[l
 */
  public void mul(double value){
    for(int i=0;i<rowCount;i++){
      rowdata[i].mul(value);
    }
    dataMax*=Math.abs(value);
  }

//--------------------------------------------------------------------//
/**
 * s̐ςvZ
 * @param left ̍s
 * @param right E̍s
 * @return 2 ̍s̐
 */
  public static Matrix mul(Matrix left,Matrix right){
    if(left.columnCount()!=right.rowCount()) return null;
    int rowCount=left.rowCount();
    int columnCount=right.columnCount();
    int n=left.columnCount();
    Matrix matrix=new SparseMatrix(rowCount,columnCount);
    for(int i=0;i<rowCount;i++){
      for(int j=0;j<columnCount;j++){
      	double sum=0.0;
      	for(int k=0;k<n;k++){
      	  sum+=left.get(i,k)*right.get(k,j);
      	}
      	if(sum!=0.0) matrix.set(i,j,sum);
      }
    }
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * s
 */
  public void init(){
    dataMax=0.0;
    for(int i=0;i<rowCount;i++){
      rowdata[i].init(i);
      dataMax=Math.max(dataMax,rowdata[i].getMax());
    }
  }

//--------------------------------------------------------------------//
/**
 * PʍsԂ
 * @param size s̑傫
 * @return w肳ꂽ傫̒Pʍs
 */
  public static Matrix unitMatrix(int size){
    SparseMatrix matrix=new SparseMatrix(size);
    for(int i=0;i<size;i++){
      matrix.set(i,i,1.0);
    }
    matrix.init();
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * ]usԂ
 * @return ̍s̓]us
 */
  public Matrix transposition(){
    Matrix matrix=new SparseMatrix(columnCount,rowCount);
    for(int i=0;i<rowCount;i++){
      int columns=rowdata[i].size();
      for(int j=0;j<columns;j++){
      	Data data=getData(i,j);
      	matrix.set(data.column,i,data.value);
      }
    }
    matrix.init();
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * ̍sƃxNg̐ςԂ
 * @param v ̍sɉE|xNg
 * @return ς̃xNg
 */
  public Vector mul(Vector v){
    if(v.size()!=columnCount) return null;
    double newv[]=new double[rowCount];
    for(int i=0;i<rowCount;i++){
      newv[i]=0.0;
      int columns=rowdata[i].size();
      for(int j=0;j<columns;j++){
      	Data data=getData(i,j);
      	newv[i]+=data.value*v.get(data.column);
      }
    }
    return new Vector(rowCount,newv);
  }

//--------------------------------------------------------------------//
/**
 * w肵sEsԂ
 * @param row s
 * @param column 
 * @return ̍s񂩂w肳ꂽsEs
 */
  public Matrix eliminateRowColumn(int row,int column){
    checkRange(row,column);
    SparseMatrix matrix=new SparseMatrix(rowCount-1,columnCount-1);
    for(int i=0;i<row;i++){
      int columns=rowdata[i].size();
      for(int j=0;j<columns;j++){
      	Data data=getData(i,j);
      	if(data.column<column){
      	  matrix.set(i,data.column,data.value);
      	}
      	else if(data.column>column){
      	  matrix.set(i,data.column-1,data.value);
      	}
      }
    }
    for(int i=row+1;i<rowCount;i++){
      int columns=rowdata[i].size();
      for(int j=0;j<columns;j++){
      	Data data=getData(i,j);
      	if(data.column<column){
      	  matrix.set(i-1,data.column,data.value);
      	}
      	else if(data.column>column){
      	  matrix.set(i-1,data.column-1,data.value);
      	}
      }
    }
    matrix.init();
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * w肵sEosԂ
 * @param size s̑傫
 * @param rows s̃CfbNXi[z
 * @param columns ̃CfbNXi[z
 * @return ̍s񂩂w肳ꂽsEos
 */
  public Matrix extructRowColumn(int size,int rows[],int columns[]){
    Matrix matrix=new SparseMatrix(size);
    for(int i=0;i<size;i++){
      int columnc=rowdata[rows[i]].size();
      int j1=0;
      int j2=0;
      while((j1<columnc) && (j2<size)){
      	Data data=getData(rows[i],j1);
      	while((j2<size) && (columns[j2]<data.column)) j2++;
      	if(columns[j2]==data.column) matrix.set(i,j2,data.value);
      	j1++;
      }
    }
    matrix.init();
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    SparseMatrix copy=(SparseMatrix)super.clone();
    copy.rowdata=new RowData[rowdata.length];
    for(int i=0;i<rowdata.length;i++){
      copy.rowdata[i]=(RowData)rowdata[i].clone();
    }
    return copy;
  }

//--------------------------------------------------------------------//
/**
 * sf[^NX
 */
  public static class RowData implements Cloneable{

/** f[^i[郊Xg */
    protected ArrayList<Data> list;

/** Ίpf[^̃CfbNX */
    protected int diagonal;

/**
 * sf[^\z
 */
    public RowData(){
      list=new ArrayList<Data>();
      diagonal=-1;
    }

//--------------------------------------------------------------------//
/**
 * Ԃ
 * @param column 
 * @return w肳ꂽʒu̐
 */
    public double get(int column){
      int col=searchColumn(column);
      if(col==-1) return 0.0;
      Data data=list.get(col);
      if(data.column==column) return data.value;
      else                    return 0.0;
    }

//--------------------------------------------------------------------//
/**
 * ΊpԂ
 * @return ̍s̑Ίp
 */
    public double getDiagonal(){
      if(diagonal<0) return 0.0;
      return list.get(diagonal).value;
    }

//--------------------------------------------------------------------//
/**
 * o
 * @param index oCfbNX
 * @return w肳ꂽʒu̐f[^
 */
    public Data getData(int index){
      return list.get(index);
    }

//--------------------------------------------------------------------//
/**
 * Ίpf[^̗CfbNXԂ
 * @return Ίpf[^̗CfbNX
 */
    public int getDiagonalColumn(){
      return diagonal;
    }

//--------------------------------------------------------------------//
/**
 * ɒl
 * @param column 
 * @param value l
 */
    public void add(int column,double value){
      if(value==0.0) return;
      int columnCount=list.size();
      if(columnCount==0){
      	addData(new Data(column,value));
      	return;
      }
      int col=searchColumn(column);
      if(col==-1){
      	addData(0,new Data(column,value));
      	return;
      }
      Data data=list.get(col);
      if(data.column==column){
      	data.add(value);
      	if(Math.abs(data.value)<=Double.MIN_VALUE){
      	  remove(col);
      	}
      }
      else{
      	addData(col+1,new Data(column,value));
      }
    }

//--------------------------------------------------------------------//
/**
 * Xg̍Ōɐf[^ǉ
 * @param data ǉ鐬f[^
 */
    public void addData(Data data){
      list.add(data);
    }

//--------------------------------------------------------------------//
/**
 * w肵ʒuɐf[^ǉ
 * @param index lǉCfbNX
 * @param data ǉ鐬f[^
 */
    public void addData(int index,Data data){
      list.add(index,data);
    }

//--------------------------------------------------------------------//
/**
 * ɒlݒ肷
 * @param column 
 * @param value ݒ肷l
 */
    public void set(int column,double value){
      int columnCount=list.size();
      if(columnCount==0){
      	if(value!=0.0){
      	  addData(new Data(column,value));
      	}
      	return;
      }
      int col=searchColumn(column);
      if(col==-1){
      	if(value!=0.0){
      	  addData(0,new Data(column,value));
      	}
      	return;
      }
      Data data=list.get(col);
      if(data.column==column){
      	if(value==0.0){
      	  remove(col);
      	}
      	else{
      	  data.set(value);
      	}
      }
      else{
      	if(value!=0.0){
      	  addData(col+1,new Data(column,value));
      	}
      }
    }

//--------------------------------------------------------------------//
/**
 * w肵ʒu̐f[^u
 * @param index lǉCfbNX
 * @param data ǉ鐬f[^
 */
    public void setData(int index,Data data){
      list.set(index,data);
    }

//--------------------------------------------------------------------//
/**
 * Ίpf[^̗CfbNXݒ肷
 * @param diagonal Ίpf[^̗CfbNX
 */
    public void setDiagonalColumn(int diagonal){
      this.diagonal=diagonal;
    }

//--------------------------------------------------------------------//
/**
 * w肵ʒu̐f[^폜
 * @param index f[^폜CfbNX
 * @return 폜ꂽf[^
 */
    public Data remove(int index){
      return list.remove(index);
    }

//--------------------------------------------------------------------//
/**
 * f[^
 */
    public void clear(){
      list.clear();
      diagonal=-1;
    }

//--------------------------------------------------------------------//
/**
 * 0 łȂ̐Ԃ
 * @return 0 łȂ̐
 */
    public int size(){
      return list.size();
    }

//--------------------------------------------------------------------//
/**
 * f[^̈ʒu
 * @param column 
 * @return w肳ꂽʒu̐f[^̗CfbNX
 */
    public int searchColumn(int column){
      int columnCount=list.size();
      if(columnCount==0) return -1;
      int column0=list.get(0).column;
      int column1=list.get(columnCount-1).column;
      if(column<column0)       return -1;
      else if(column==column0) return 0;
      else if(column>=column1) return columnCount-1;

      int low=0;
      int high=columnCount-1;
      int mid=(low+high)/2;
      do{
      	column0=list.get(mid).column;
      	if(column0<column)      low=mid+1;
      	else if(column0>column) high=mid;
      	else                    return mid;
      	mid=(low+high)/2;
      }while(low<high);
      return mid-1;
    }

//--------------------------------------------------------------------//
/**
 * ̐Βl̍őlԂ
 * @return ̍s̐̐Βl̍ől
 */
    public double getMax(){
      double dataMax=0.0;
      int columns=list.size();
      for(int i=0;i<columns;i++){
      	dataMax=Math.max(dataMax,Math.abs(list.get(i).value));
      }
      return dataMax;
    }

//--------------------------------------------------------------------//
/**
 * XJ[|
 * @param value |XJ[l
 */
    public void mul(double value){
      if(value==0.0){
      	clear();
      }
      else{
      	int columns=list.size();
      	for(int i=0;i<columns;i++){
      	  list.get(i).mul(value);
      	}
      }
    }

//--------------------------------------------------------------------//
/**
 * sf[^
 * @param row s̃CfbNX
 */
    public void init(int row){
      Collections.sort(list);
      list.trimToSize();
      diagonal=-1;
      int columns=list.size();
      for(int i=0;i<columns;i++){
      	if(list.get(i).column==row) diagonal=i;
      }
    }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
    public Object clone(){
      try{
      	RowData copy=(RowData)super.clone();
      	int columnCount=list.size();
      	copy.list=new ArrayList<Data>(columnCount);
      	for(int i=0;i<columnCount;i++){
      	  copy.list.add((Data)list.get(i).clone());
      	}
      	return copy;
      }
      catch(CloneNotSupportedException ex){
      	throw new InternalError();
      }
    }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
    public int hashCode(){
      int bit=diagonal;
      int size=list.size();
      for(int i=0;i<size;i++){
      	Data data=(Data)list.get(i);
      	bit=31*bit+data.hashCode();
      }
      return bit;
    }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>RowData</code>
 *         ̃CX^Xœlꍇ true
 */
    public boolean equals(Object obj){
      if(obj instanceof RowData){
      	RowData row=(RowData)obj;
      	if(diagonal!=row.diagonal) return false;
      	int size=list.size();
      	if(size!=row.list.size()) return false;
      	for(int i=0;i<size;i++){
      	  if(!list.get(i).equals(row.getData(i))) return false;
      	}
      	return true;
      }
      return false;
    }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
    public String toString(){
      StringBuilder sb=new StringBuilder();
      int size=list.size();
      sb.append(diagonal);
      sb.append('\n');
      sb.append(size);
      for(int i=0;i<size;i++){
      	Data data=list.get(i);
      	sb.append('\n');
      	sb.append(data.column);
      	sb.append('\n');
      	sb.append(data.value);
      }
      return sb.toString();
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^NX
 */
  public static class Data implements Cloneable,Comparable<Data>{

/**  */
    public int column;

/** ̒l */
    public double value;

/**
 * f[^\z
 * @param column 
 * @param value ̒l
 */
    public Data(int column,double value){
      this.column=column;
      this.value=value;
    }

//--------------------------------------------------------------------//
/**
 * ̒lݒ肷
 * @param value ̒l
 */
    public void set(double value){
      this.value=value;
    }

//--------------------------------------------------------------------//
/**
 * ɒl
 * @param value l
 */
    public void add(double value){
      this.value+=value;
    }

//--------------------------------------------------------------------//
/**
 * ɒl|
 * @param coef |l
 */
    public void mul(double coef){
      value*=coef;
    }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
    public Object clone(){
      try{
      	return super.clone();
      }
      catch(CloneNotSupportedException ex){
      	throw new InternalError();
      }
    }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
    public int hashCode(){
      long l=Double.doubleToLongBits(value);
      return 31*column+(int)(l^(l>>>32));
    }

//--------------------------------------------------------------------//
/**
 * IuWFNg̓
 * @param obj rΏۂ̃IuWFNg
 * @return rΏۂ̃IuWFNg <code>Data</code>
 *         ̃CX^Xœlꍇ true
 */
    public boolean equals(Object obj){
      if(obj instanceof Data){
      	Data data=(Data)obj;
      	return ((column==data.column) && (value==data.value));
      }
      return false;
    }

//--------------------------------------------------------------------//
/**
 * IuWFNg̔r
 * @param data rΏۂ̃f[^
 */
    public int compareTo(Data data){
      return column-data.column;
    }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
    public String toString(){
      return column+"\t"+value;
    }
  }
}
