package figure;
import java.awt.geom.Point2D;
import java.util.Arrays;

//--------------------------------------------------------------------//
/**
 * 3WϊNX
 */
public class Transform implements Cloneable{

/** ϊs̐i[z */
  protected double trans[][];

/**
 * ϊs\z
 */
  public Transform(){
    trans=new double[3][4];
    init();
  }

//--------------------------------------------------------------------//
/**
 * Wϊ
 * @param p ϊ_\ <code>Point3D</code>
 */
  public void trans(Point3D p){
    double x=trans[0][0]*p.x+trans[0][1]*p.y+trans[0][2]*p.z+trans[0][3];
    double y=trans[1][0]*p.x+trans[1][1]*p.y+trans[1][2]*p.z+trans[1][3];
    double z=trans[2][0]*p.x+trans[2][1]*p.y+trans[2][2]*p.z+trans[2][3];
    p.setLocation(x,y,z);
  }

//--------------------------------------------------------------------//
/**
 * Wϊ
 * @param p ϊ_\ <code>Point3D</code>
 */
  public void trans(Point2D p){
    double x=trans[0][0]*p.getX()+trans[0][1]*p.getY()+trans[0][3];
    double y=trans[1][0]*p.getX()+trans[1][1]*p.getY()+trans[1][3];
    p.setLocation(x,y);
  }

//--------------------------------------------------------------------//
/**
 * ϊs
 */
  public void init(){
    for(int i=0;i<3;i++){
      for(int j=0;j<4;j++){
      	if(i==j) trans[i][j]=1.0;
      	else     trans[i][j]=0.0;
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * ]ϊ
 * @param rx <i>x</i> ̉]p
 * @param ry <i>y</i> ̉]p
 * @param rz <i>z</i> ̉]p
 */
  public void rotate(double rx,double ry,double rz){
    double theta=Math.sqrt(rx*rx+ry*ry+rz*rz);
    if(theta==0.0) return;
    double rc=1.0/theta;
    rotate(rc*rx,rc*ry,rc*rz,theta);
  }

//--------------------------------------------------------------------//
/**
 * ]ϊ
 * @param rx ]p <i>x</i> 
 * @param ry ]p <i>y</i> 
 * @param rz ]p <i>z</i> 
 * @param theta ]p
 */
  public void rotate(double rx,double ry,double rz,double theta){
    double cc=Math.cos(theta);
    double ss=Math.sin(theta);
    double m[][]={{cc+(1.0-cc)*rx*rx,-rz*ss+(1.0-cc)*rx*ry,
      	      	   ry*ss+(1.0-cc)*rx*rz},
      	      	  {rz*ss+(1.0-cc)*ry*rx,cc+(1.0-cc)*ry*ry,
      	      	   -rx*ss+(1.0-cc)*ry*rz},
      	      	  {-ry*ss+(1.0-cc)*rz*rx,rx*ss+(1.0-cc)*rz*ry,
      	      	   cc+(1.0-cc)*rz*rz}};
    double newT[][]=new double[3][3];
    for(int i=0;i<3;i++){
      for(int j=0;j<3;j++){
      	newT[i][j]=0.0;
      	for(int k=0;k<3;k++){
      	  newT[i][j]+=m[i][k]*trans[k][j];
      	}
      }
    }
    for(int i=0;i<3;i++){
      for(int j=0;j<3;j++){
      	trans[i][j]=newT[i][j];
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * sړ
 * @param dx <i>x</i> ړ
 * @param dy <i>y</i> ړ
 * @param dz <i>z</i> ړ
 */
  public void translate(double dx,double dy,double dz){
    trans[0][3]+=dx;
    trans[1][3]+=dy;
    trans[2][3]+=dz;
  }

//--------------------------------------------------------------------//
/**
 * gEk
 * @param c gEk{
 */
  public void zoom(double c){
    for(int i=0;i<3;i++){
      for(int j=0;j<4;j++){
      	trans[i][j]*=c;
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃Rs[Ԃ
 * @return ̃CX^X̕
 */
  public Object clone(){
    try{
      Transform tr=(Transform)super.clone();
      tr.trans=new double[3][4];
      for(int i=0;i<3;i++){
      	for(int j=0;j<4;j++){
      	  tr.trans[i][j]=trans[i][j];
      	}
      }
      return tr;
    }
    catch(CloneNotSupportedException ex){
      throw new InternalError();
    }
  }

//--------------------------------------------------------------------//
/**
 * IuWFNg̃nbVR[hlԂ
 * @return IuWFNg̃nbVR[hl
 */
  public int hashCode(){
    int bit=0;
    for(int i=0;i<3;i++){
      for(int j=0;j<4;j++){
      	long ll=Double.doubleToLongBits(trans[i][j]);
      	bit=31*bit+(int)(ll^(ll>>>32));
      }
    }
    return bit;
  }

//--------------------------------------------------------------------//
/**
 * 
 * @return rΏۂ̃IuWFNg <code>Transform</code>
 *         ̃CX^Xœlꍇ true
 */
  public boolean equals(Object obj){
    if(obj instanceof Transform){
      Transform t=(Transform)obj;
      return (Arrays.equals(trans[0],t.trans[0])
      	   && Arrays.equals(trans[1],t.trans[1])
      	   && Arrays.equals(trans[2],t.trans[2]));
    }
    else{
      return false;
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    StringBuilder sb=new StringBuilder("Transform");
    for(int i=0;i<3;i++){
      for(int j=0;j<4;j++){
      	sb.append('\t');
      	sb.append(trans[i][j]);
      }
      sb.append('\n');
    }
    return sb.toString();
  }
}
