package figure.matrix;
import java.util.Arrays;
import figure.DefaultMatrix;
import figure.Matrix;
import figure.Vector;

//--------------------------------------------------------------------//
/**
 * Ả߂邽߂̕WsNX
 */
public class DefaultMatrixSolver
  extends DefaultMatrix implements MatrixSolver{

/**
 * s\z
 * @param size s̑傫
 */
  public DefaultMatrixSolver(int size){
    super(size);
  }

//--------------------------------------------------------------------//
/**
 * w肵sEosԂ
 * @param size s̑傫
 * @param rows s̃CfbNXi[z
 * @param columns ̃CfbNXi[z
 * @return ̍s񂩂w肳ꂽsEos
 */
  public Matrix extructRowColumn(int size,int rows[],int columns[]){
    return extruct(size,rows,columns);
  }

//--------------------------------------------------------------------//
/**
 * w肵sEosԂ
 * @param size s̑傫
 * @param rows s̃CfbNXi[z
 * @param columns ̃CfbNXi[z
 * @return ̍s񂩂w肳ꂽsEos
 */
  public MatrixSolver extruct(int size,int rows[],int columns[]){
    MatrixSolver matrix=new DefaultMatrixSolver(size);
    for(int i=0;i<size;i++){
      for(int j=0;j<size;j++){
      	matrix.set(i,j,data[rows[i]][columns[j]]);
      }
    }
    matrix.init();
    return matrix;
  }

//--------------------------------------------------------------------//
/**
 * Ả߂
 * @param p xNg <i>p</i>
 * @param method s@
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solve(Vector p,MatrixSolveMethod method)
    throws MatrixSolveException{

    double param[]=MatrixSolveParameter.getParameters(method);
    switch(method){
      case GAUSS:
      	return solveByGauss(p,param[0]);
      case GAUSS_JORDAN:
      	return solveByGaussJordan(p,param[0]);
      case LU:
      	return solveByLU(p,param[0]);
      case SOR:
      	return solveBySOR(p,param[0],(int)param[1],param[2]);
      case CG:
      	return solveByCG(p,param[0],(int)param[1]);
      case ILUCG:
      	return solveByILUCG(p,param[0],(int)param[1]);
    }
    return null;
  }

//--------------------------------------------------------------------//
/**
 * KEX@ŘẢ߂
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByGauss(Vector p,double tolerance)
    throws MatrixSolveException{

    DefaultMatrixSolver m=(DefaultMatrixSolver)clone();
    return m.solveByGaussNoPreserv(p,tolerance);
  }

//--------------------------------------------------------------------//
/**
 * KEX@ŘẢ߂<br>
 * ̍s͕ێȂ
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByGaussNoPreserv(Vector p,double tolerance)
    throws MatrixSolveException{

    int size=p.size();
    tolerance*=dataMax;
    Vector x=(Vector)p.clone();
    for(int i=0;i<size-1;i++){
      if(Math.abs(data[i][i])<tolerance){
      	throw new MatrixSolveException();
      }
      double minv=1.0/data[i][i];
      for(int j=i+1;j<columnCount;j++){
      	double mji=-minv*data[j][i];
      	for(int k=i+1;k<columnCount;k++){
      	  data[j][k]+=mji*data[i][k];
      	}
      	x.add(j,mji*x.get(i));
      }
      for(int j=i+1;j<columnCount;j++){
      	data[i][j]*=minv;
      }
      x.set(i,minv*x.get(i));
    }
    if(Math.abs(data[size-1][size-1])<tolerance){
      throw new MatrixSolveException();
    }
    x.set(size-1,x.get(size-1)/data[size-1][size-1]);
    for(int i=size-2;i>=0;i--){
      double s=0.0;
      for(int j=i+1;j<size;j++){
      	s-=data[i][j]*x.get(j);
      }
      x.add(i,s);
    }
    return x;
  }

//--------------------------------------------------------------------//
/**
 * Gauss - Jordan @ŘẢ߂
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByGaussJordan(Vector p,double tolerance)
    throws MatrixSolveException{

    DefaultMatrixSolver m=(DefaultMatrixSolver)clone();
    return m.solveByGaussJordanNoPreserv((Vector)p.clone(),tolerance);
  }

//--------------------------------------------------------------------//
/**
 * Gauss - Jordan @ŘẢ߂
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByGaussJordanNoPreserv(Vector p,double tolerance)
    throws MatrixSolveException{

    int size=p.size();
    tolerance*=dataMax;
    int index[]=new int[size];
    for(int i=0;i<size;i++) index[i]=i;

    for(int i=0;i<size;i++){
      double dmax=Math.abs(data[i][i]);
      int kmax=i;
      for(int k=i+1;k<size;k++){
      	if(Math.abs(data[i][k])>dmax){
      	  dmax=Math.abs(data[i][k]);
      	  kmax=k;
      	}
      }
      if(dmax<tolerance){
      	throw new MatrixSolveException();
      }
      if(i!=kmax){
      	for(int j=0;j<size;j++){
      	  dmax=data[j][i];
      	  data[j][i]=data[j][kmax];
      	  data[j][kmax]=dmax;
      	}
      	int itemp=index[i];
      	index[i]=index[kmax];
      	index[kmax]=itemp;
      }
      double minv=1.0/data[i][i];
      for(int k=i+1;k<size;k++){
      	data[i][k]*=minv;
      }
      p.set(i,minv*p.get(i));
      for(int j=0;j<size;j++){
      	double mji=-data[j][i];
      	if((i!=j) && (mji!=0.0)){
      	  for(int k=i+1;k<size;k++){
      	    data[j][k]+=mji*data[i][k];
      	  }
      	  p.add(j,mji*p.get(i));
      	}
      }
    }
    Vector x=new Vector(size);
    for(int i=0;i<size;i++) x.set(index[i],p.get(i));
    return x;
  }

//--------------------------------------------------------------------//
/**
 * LU 
 * @param tolerance 臒l
 * @return ̍s LU s
 * @throws MatrixSolveException LU łȂƂ
 */
  public Matrix getLU(double tolerance) throws MatrixSolveException{
    DefaultMatrixSolver lu=(DefaultMatrixSolver)clone();
    lu.toLU(tolerance);
    return lu;
  }

//--------------------------------------------------------------------//
/**
 * ̍s LU 
 * @param tolerance 臒l
 * @throws MatrixSolveException LU łȂƂ
 */
  public void toLU(double tolerance) throws MatrixSolveException{
    tolerance*=dataMax;
    for(int i=0;i<rowCount-1;i++){
      if(Math.abs(data[i][i])<tolerance){
      	throw new MatrixSolveException();
      }
      double minv=1.0/data[i][i];
      for(int j=i+1;j<rowCount;j++){
      	data[i][j]*=minv;
      }
      for(int j=i+1;j<rowCount;j++){
      	double mji=-data[j][i];
      	if(mji!=0.0){
      	  for(int k=i+1;k<rowCount;k++){
      	    data[j][k]+=mji*data[i][k];
      	  }
      	}
      }
    }
    if(Math.abs(data[rowCount-1][rowCount-1])<tolerance){
      throw new MatrixSolveException();
    }
    init();
  }

//--------------------------------------------------------------------//
/**
 * LU @ŘẢ߂
 * @param lu LU ꂽs
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public static Vector solveByLU(DefaultMatrix lu,Vector p,
      	      	      	      	 double tolerance)
    throws MatrixSolveException{

    tolerance*=lu.dataMax;
    int size=p.size();
    double q[]=new double[size];
    if(Math.abs(lu.get(0,0))<tolerance){
      throw new MatrixSolveException();
    }
    q[0]=p.get(0)/lu.get(0,0);
    for(int i=1;i<size;i++){
      double p2=p.get(i);
      for(int j=0;j<i;j++){
      	p2-=lu.get(i,j)*q[j];
      }
      if(Math.abs(lu.get(i,i))<tolerance){
      	throw new MatrixSolveException();
      }
      q[i]=p2/lu.get(i,i);
    }
    for(int i=size-2;i>=0;i--){
      for(int j=i+1;j<size;j++){
      	q[i]-=lu.get(i,j)*q[j];
      }
    }
    return new Vector(size,q);
  }

//--------------------------------------------------------------------//
/**
 * LU @ŘẢ߂
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByLU(Vector p,double tolerance)
    throws MatrixSolveException{

    DefaultMatrixSolver m=(DefaultMatrixSolver)clone();
    return m.solveByLUNoPreserv(p,tolerance);
  }

//--------------------------------------------------------------------//
/**
 * I LU @ŘẢ߂<br>
 * ̍s͕ێȂ
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByLUNoPreserv(Vector p,double tolerance)
    throws MatrixSolveException{

    int size=p.size();
    tolerance*=dataMax;
    int index[]=new int[size];
    for(int i=0;i<size;i++) index[i]=i;

    double q[]=new double[size];
    for(int i=0;i<size-1;i++){
      double p2=p.get(i);
      for(int j=0;j<i;j++){
      	p2-=data[i][j]*q[j];
      }

      double dmax=Math.abs(data[i][i]);
      int kmax=i;
      for(int k=i+1;k<size;k++){
      	if(Math.abs(data[i][k])>dmax){
      	  dmax=Math.abs(data[i][k]);
      	  kmax=k;
      	}
      }
      if(dmax<tolerance){
      	throw new MatrixSolveException
      	  ("matrix solve error at row "+(i+1)+"/"+size);
      }
      if(i!=kmax){
      	for(int j=0;j<size;j++){
      	  dmax=data[j][i];
      	  data[j][i]=data[j][kmax];
      	  data[j][kmax]=dmax;
      	}
      	int itemp=index[i];
      	index[i]=index[kmax];
      	index[kmax]=itemp;
      }

      double minv=1.0/data[i][i];
      for(int j=i+1;j<size;j++){
      	data[i][j]*=minv;
      }
      for(int j=i+1;j<size;j++){
      	double mji=-data[j][i];
      	if(mji!=0.0){
      	  for(int k=i+1;k<size;k++){
      	    data[j][k]+=mji*data[i][k];
      	  }
      	}
      }
      q[i]=p2*minv;
    }
    if(Math.abs(data[size-1][size-1])<tolerance){
      throw new MatrixSolveException
      	("matrix solve error at row "+size+"/"+size);
    }
    double p2=p.get(size-1);
    for(int j=0;j<size-1;j++){
      p2-=data[size-1][j]*q[j];
    }
    q[size-1]=p2/data[size-1][size-1];

    for(int i=size-2;i>=0;i--){
      for(int j=i+1;j<size;j++){
      	q[i]-=data[i][j]*q[j];
      }
    }

    Vector x=new Vector(size);
    for(int i=0;i<size;i++) x.set(index[i],q[i]);
    return x;
  }

//--------------------------------------------------------------------//
/**
 * SOR @ŘẢ߂
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @param iterMax 񐔂̏
 * @param relax ɘaW
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveBySOR(Vector p,double tolerance,int iterMax,
      	      	      	   double relax)
    throws MatrixSolveException{

    double tol2=tolerance*dataMax;
    int size=p.size();
    Vector x=new Vector(size);
    double mat[][]=new double[size][size];
    double b[]=new double[size];
    for(int i=0;i<size;i++){
      if(Math.abs(data[i][i])<tol2){
      	throw new MatrixSolveException();
      }
      double minv=1.0/data[i][i];
      for(int j=0;j<size;j++){
      	mat[i][j]=minv*data[i][j];
      }
      b[i]=minv*p.get(i);
    }
    for(int iter=0;iter<iterMax;iter++){
      double eps1=0.0;
      double eps2=0.0;
      for(int i=0;i<size;i++){
      	double xnew=b[i];
      	for(int j=0;j<i;j++){
      	  xnew-=mat[i][j]*x.get(j);
      	}
      	for(int j=i+1;j<size;j++){
      	  xnew-=mat[i][j]*x.get(j);
      	}
      	double xold=x.get(i);
      	xnew=xold+relax*(xnew-xold);
      	x.set(i,xnew);
      	eps1+=(xnew-xold)*(xnew-xold);
      	eps2+=xnew*xnew;
      }
      if(eps1<tolerance*eps2) return x;
    }
    return x;
  }

//--------------------------------------------------------------------//
/**
 * z@ŘẢ߂
 * @param p xNg <i>p</i>
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByCG(Vector p,double tolerance)
    throws MatrixSolveException{
    return solveByCG(p,tolerance,p.size());
  }

//--------------------------------------------------------------------//
/**
 * z@ŘẢ߂
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @param iterMax 񐔂̏
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByCG(Vector p,double tolerance,int iterMax)
    throws MatrixSolveException{

    double tol1=tolerance*dataMax;
    double tol2=tolerance*Vector.innerProduct(p,p);
    int size=p.size();
    Vector x=new Vector(size);
    Vector xg=(Vector)p.clone();
    Vector xd=(Vector)xg.clone();

    iterMax=Math.min(iterMax,rowCount);
    for(int iter=0;iter<iterMax;iter++){
      Vector xq=xd.mul(this);
      double r=Vector.innerProduct(xd,xq);
      if(Math.abs(r)<tol1){
      	throw new MatrixSolveException();
      }
      double alpha=Vector.innerProduct(xd,xg)/r;
      x.add(alpha,xd);
      xg.add(-alpha,xq);
      if(Vector.innerProduct(xg,xg)<tol2) return x;
      double beta=-Vector.innerProduct(xg,xq)/r;
      xd.mul(beta);
      xd.add(xg);
    }
    return x;
  }

//--------------------------------------------------------------------//
/**
 * sS LU z@ŘẢ߂
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByILUCG(Vector p,double tolerance)
    throws MatrixSolveException{
    return solveByILUCG((DefaultMatrix)getILU(tolerance),p,tolerance,
      	      	      	p.size());
  }

//--------------------------------------------------------------------//
/**
 * sS LU z@ŘẢ߂
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @param iterMax 񐔂̏
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByILUCG(Vector p,double tolerance,int iterMax)
    throws MatrixSolveException{
    return solveByILUCG((DefaultMatrix)getILU(tolerance),p,tolerance,
      	      	      	iterMax);
  }

//--------------------------------------------------------------------//
/**
 * sS LU z@ŘẢ߂
 * @param lu sS LU ꂽs
 * @param p xNg <i>p</i>
 * @param tolerance 臒l
 * @param iterMax 񐔂̏
 * @return Ả\xNg
 * @throws MatrixSolveException Ả܂ȂƂ
 */
  public Vector solveByILUCG(DefaultMatrix lu,Vector p,double tolerance,
      	      	      	     int iterMax)
    throws MatrixSolveException{

    double tol1=tolerance*Vector.innerProduct(p,p);
    double tol2=tolerance*tol1;
    int size=p.size();
    Vector x=new Vector(size);
    Vector xg=(Vector)p.clone();
    Vector xq=solveByLU(lu,xg);
    Vector xd=(Vector)xq.clone();

    iterMax=Math.min(iterMax,rowCount);
    for(int iter=0;iter<iterMax;iter++){
      double z1=Vector.innerProduct(xd,xg);
      xq=xd.mul(this);
      double r=Vector.innerProduct(xd,xq);
      if(Math.abs(r)<tol2){
      	throw new MatrixSolveException();
      }
      double alpha=z1/r;
      x.add(alpha,xd);
      xg.add(-alpha,xq);
      if(Vector.innerProduct(xg,xg)<tol1) return x;
      Vector xq2=solveByLU(lu,xg);
      double z2=Vector.innerProduct(xq,xq2);
      double beta=-z2/r;
      xd.mul(beta);
      xd.add(xq2);
    }
    return x;
  }

//--------------------------------------------------------------------//
/**
 * sS LU 
 * @param tolerance 臒l
 * @return ̍ssS LU s
 * @throws MatrixSolveException sS LU łȂƂ
 */
  public Matrix getILU(double tolerance) throws MatrixSolveException{
    tolerance*=dataMax;
    DefaultMatrix lu=(DefaultMatrix)clone();
    for(int i=0;i<rowCount-1;i++){
      if(Math.abs(lu.get(i,i))<tolerance){
      	throw new MatrixSolveException();
      }
      double akk=1.0/lu.get(i,i);
      for(int j=i+1;j<rowCount;j++){
      	lu.set(i,j,akk*lu.get(i,j));
      }
      for(int j=i+1;j<rowCount;j++){
      	double mji=-lu.get(j,i);
      	if(mji!=0.0){
      	  for(int k=i+1;k<rowCount;k++){
      	    if(lu.get(j,k)!=0.0) lu.add(j,k,mji*lu.get(i,k));
      	  }
      	}
      }
    }
    lu.init();
    return lu;
  }

//--------------------------------------------------------------------//
/**
 * ts߂
 * @return ̍s̋ts
 * @throws MatrixSolveException ts񂪋܂ȂƂ
 */
  public MatrixSolver inverse() throws MatrixSolveException{
    DefaultMatrixSolver m=(DefaultMatrixSolver)clone();
    return m.inverseNoPreserv(TOLERANCE);
  }

//--------------------------------------------------------------------//
/**
 * LU @ŋts߂
 * @param lu LU ꂽs
 * @param tolerance 臒l
 * @return ̍s̋ts
 * @throws MatrixSolveException ts񂪋܂ȂƂ
 */
  public static MatrixSolver inverse(DefaultMatrix lu,double tolerance)
    throws MatrixSolveException{

    tolerance*=lu.dataMax;
    int size=lu.rowCount();
    DefaultMatrixSolver ai=new DefaultMatrixSolver(size);
    for(int i=0;i<size;i++){
      if(Math.abs(lu.get(i,i))<tolerance){
      	throw new MatrixSolveException();
      }
    }
    ai.set(size-1,size-1,1.0/lu.get(size-1,size-1));
    for(int i=size-2;i>=0;i--){
      for(int j=i;j>=0;j--){
      	double a1=0.0;
      	double a2=0.0;
      	for(int k=j+1;k<size;k++){
      	  a1-=lu.get(j,k)*ai.get(k,i+1);
      	  a2-=ai.get(i+1,k)*lu.get(k,j);
      	}
      	ai.set(j,i+1,a1);
      	ai.set(i+1,j,a2/lu.get(j,j));
      }
      double a1=1.0;
      for(int k=i+1;k<size;k++){
      	a1-=ai.get(i,k)*lu.get(k,i);
      }
      ai.set(i,i,a1/lu.get(i,i));
    }
    ai.init();
    return ai;
  }

//--------------------------------------------------------------------//
/**
 * ts߂<br>
 * ̍s͕ێȂ
 * @param tolerance 臒l
 * @return s̋ts
 * @throws MatrixSolveException ts񂪋܂ȂƂ
 */
  public DefaultMatrixSolver inverseNoPreserv(double tolerance)
    throws MatrixSolveException{

    tolerance*=dataMax;
    for(int i=0;i<rowCount-1;i++){
      if(Math.abs(data[i][i])<tolerance){
      	throw new MatrixSolveException();
      }
      double minv=1.0/data[i][i];
      for(int j=i+1;j<rowCount;j++){
      	data[i][j]*=minv;
      }
      for(int j=i+1;j<rowCount;j++){
      	double mji=-data[j][i];
      	if(mji!=0.0){
      	  for(int k=i+1;k<rowCount;k++){
      	    data[j][k]+=mji*data[i][k];
      	  }
      	}
      }
    }
    if(Math.abs(data[rowCount-1][rowCount-1])<tolerance){
      throw new MatrixSolveException();
    }

    DefaultMatrixSolver ai=new DefaultMatrixSolver(rowCount);
    ai.set(rowCount-1,rowCount-1,1.0/data[rowCount-1][rowCount-1]);
    for(int i=rowCount-2;i>=0;i--){
      for(int j=i;j>=0;j--){
      	double a1=0.0;
      	double a2=0.0;
      	for(int k=j+1;k<rowCount;k++){
      	  a1+=data[j][k]*ai.get(k,i+1);
      	  a2+=ai.get(i+1,k)*data[k][j];
      	}
      	ai.set(j,i+1,-a1);
      	ai.set(i+1,j,-a2/data[j][j]);
      }
      double a1=0.0;
      for(int k=i+1;k<rowCount;k++){
      	a1+=ai.get(i,k)*data[k][i];
      }
      ai.set(i,i,(1.0-a1)/data[i][i]);
    }
    ai.init();
    return ai;
  }
}
